//******************************************************************************
// This class is part of the Sizmek Image Gallery Ad Features
// ALL RIGHTS RESERVED TO © 2018 Sizmek.
//******************************************************************************
//******************************************************************************
(function() {
	// Define Method - Update "FeatureName" with name of Ad Feature
	window.ImageGallery = function(_c) {

		"use strict";

		// Verify that Adkit
		if (document.location.protocol !== "file:" && (typeof EB === "undefined" || typeof EBG === "undefined")) {
			// Console error
			log('Adkit not ready');
			// abandon script
			return false;
		}

		// Save Reference to Script Name
		var scriptName = "ImageGallery";
		// Script Version
		var scriptVersion = "3.0.0";
		// Last Modified
		var lastModified = "2018-05-22";
		// Last Uploaded
		var lastUploaded = "2018-03-22";
		// Template Version
		var templateVersion = "2.0.4";
		// Block Id
		var blockId = 6143;

		// Establish Config Object
		var config = _c;
		// Establish Boolean for tracking
		var isDebug = false;
		// Establish Boolean for tracking
		var trackOnce = true;

		// Establish reference for unique id
		var uid;
		// Establish reference to div container
		var container;
		// Establish reference to swipe navigator
		var swipeNavigator;

		var clientDetector;

		var VwTrackedObjectCount;

		var VwTween;

		var VwTwnInst;

		window.VwTwnDelegate = function() {};

		// Establish index
		var currentIndex = 0;
		// Establish reference for css prefix
		var cssPrefix = "imageGallery";
		// Establish Width of Gallery from config object
		var galleryWidth = config.width;
		// Establish Height of Gallery from config object
		var galleryHeight = config.height;
		// init boolean
		var proceeded = false;

		var browserType = EB._browserData ? EB._browserData.browserType : 1;
		// Establish reference for if on mobile
		var isMobileDevice = EB._browserData ? EB._browserData.isMobile : false;
		// Establish boolean for touch event
		var useTouchEvent = isMobileDevice;
		// Establish reference for if on mobile
		var isIE = EB._browserData && browserType === 1 ? true : false;

		var browserVersion = EB._browserData ? EB._browserData.browserVer : 10;
		// Establish if using webkit
		var isWebkit = EB._browserData && (browserType === 4 || browserType === 5) ? true : false;
		// Determine if supports touch
		var supportsTouch = EB._browserData && (EB._browserData.isAndroid || this.isIOS || !!document.createTouch) ? true : false;

		// Establish object for default options
		var availableOptions = {
			"eventNamePrefix": "Image_Gallery",
			"dimensionOverride": "none",
			"imageSmartLoader": true,
			"showImageCaption": true,
			"showNavigationBar": true,
			"showImageIndicator": true
		};
		// Establish object for templates
		var availableTemplates = {
			"caption": "{IMAGE_CAPTION}",
			"indicator": "&#8226;"
		};
		// Establish array for default css
		var availableCSS = ["galleryStage", "imageCaptionBar", "imageLoader", "leftNavigation", "rightNavigation", "indicatorBar", "indicatorOn", "indicatorOff"];

		// Function That Creates Element Var
		var d = function(_id) {
			return document.getElementById(_id);
		};
		// Function That Creates Unique ID
		var genUid = function() {
			return Math.ceil((new Date()).valueOf() * Math.random()).toString().substr(0, 7);
		};

		// Run throw config and overwrite default options if necessary
		var fetchOptions = function() {
			// Loop through object
			Object.keys(availableOptions).forEach(function(key) {
				// verify config has options object
				if (config.hasOwnProperty("options") && config.options.hasOwnProperty(key)) {
					// overwrite key with value from config
					availableOptions[key] = config.options[key];
				}
			});
		};

		var fetchTemplates = function() {
			// Loop through object
			Object.keys(availableTemplates).forEach(function(key) {
				// verify config has templates object
				if (config.hasOwnProperty("templates") && config.templates.hasOwnProperty(key)) {
					// overwrite key with value from config
					availableTemplates[key] = config.templates[key];
				}
			});
		};

		// Overwrite default CSS with custom CSS from config
		var fetchCustomCSS = function() {
			// Loop through default css and add custom prefix
			for (var i = 0; i < availableCSS.length; i++) {
				availableCSS[i] = cssPrefix + " " + availableCSS[i];
			}

			// Verify config has Custom CSS
			if (config.hasOwnProperty("customCSS")) {
				// loop through CustomCSS
				for (i = 0; i < config.customCSS.length; i++) {
					// Create new var from config, split name from value
					var defaultName = config.customCSS[i].split("=")[0].replace(/^\s*/, "").replace(/\s*$/, "");
					var newName = config.customCSS[i].split("=")[1].replace(/^\s*/, "").replace(/\s*$/, "");
					defaultName = defaultName.replace(cssPrefix, "").replace(/\./g, "");
					newName = newName.substr(0, 1) == "." ? newName.substr(1, newName.length) : newName;
					for (var j = 0; j < availableCSS.length; j++) {
						if (defaultName === availableCSS[j]) {
							// Update default with new custom css
							availableCSS[j] = cssPrefix + newName.replace(/\./g, " ");
						}
					}
				}
			}
		};

		// Set up Script
		var init = function() {
			// Create unique id
			uid = genUid();
			// Establish reference to container div from config
			container = d(config.container);
			// overwrite clickthrough that may have been registered in index
			config.actionRegister = undefined;

			// Update Options with config
			fetchOptions();
			// Update Templates with config
			fetchTemplates();
			// Update CSS with config
			fetchCustomCSS();

			window.getEquivalentDeviceInputFromTouch = getEquivalentDeviceInputFromTouch;
			// 			window.convertPointerEventToTouch = convertPointerEventToTouch;
			window.getPointerPosition = getPointerPosition;
			window.getCurrentStyle = getCurrentStyle;

			if (!VwTrackedObjectCount) {
				VwTrackedObjectCount = 0;
			}

			// Check if nav is necessary, if not, set boolean
			if (config.images.length === 1) {
				availableOptions.showNavigationBar = false;
			}

			// Check if using fullscreen template
			if (availableOptions.dimensionOverride === "fullscreen") {
				// set gallery width to window
				galleryWidth = document.width;
				// Set gallery height to window
				galleryHeight = document.height;
				// Check if using images template
			}
			else if (availableOptions.dimensionOverride == "images") {
				// loop through images in config
				for (var i = 0; i < config.images.length; i++) {
					// set gallery width to largest images width
					galleryWidth = Math.max(galleryWidth, config.images[i].width);
					// set gallery height to largest images height
					galleryHeight = Math.max(galleryHeight, config.images[i].height);
				}
			}

			// begin to build Image Gallery
			buildImageGallery();
		};

		// Create Image Tag
		var getImageTag = function(_img) {
			// Build html
			var code = "<div style='position:relative;top:0px;left:0px;width:100%;height:100%;z-index:0;'><table border='0' width='100%' height='100%' cellpadding='0' cellspacing='0'><tr><td align='center' valign='middle'>";
			// Set initial width
			var imgWidth = 0;
			// Set initial height
			var imgHeight = 0;
			// Check if using images template
			if (availableOptions.dimensionOverride == "images") {
				// Set width to config image width
				imgWidth = config.images[_img].width;
				// Set height to config image height
				imgHeight = config.images[_img].height;
			}
			else {
				// Set width to config width
				imgWidth = galleryWidth;
				// Set width to config height
				imgHeight = galleryHeight;
			}
			// continue to build html with uid, image, width and height
			code += "<img id='" + uid + "_ImgImage_" + _img + "' src='" + config.images[_img].source + "' border='0' style='width:" + imgWidth + "px;height:" + imgHeight + "px;visibility:hidden;'/>";
			code += "</td></tr></table></div>";
			code += '<div style="position:absolute;top:0px;left:0px;width:100%;height:100%;display:block;font-size:1000px;z-index:0;cursor:default;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</div>';
			code += "<div id='" + uid + "_ImgCaption_" + _img + "' style='max-width:" + galleryWidth + "px;display:none;' class='" + availableCSS[1] + "'>" + availableTemplates.caption.replace(/{IMAGE_CAPTION}/g, (config.images[_img].caption ? config.images[_img].caption : "")) + "</div>";
			// return html
			return code;
		};

		// Determine width and height of gallery
		var getAdjustedImageDimension = function(_imageObj) {
			// create reference to the original width of image
			var originalWidth = _imageObj.naturalWidth;
			// create reference to the original height of image
			var originalHeight = _imageObj.naturalHeight;
			// create reference to the gallery width
			var imageWidth = galleryWidth;
			// create reference to the gallery height
			var imageHeight = galleryHeight;

			// make sure we don't want fullscreen
			if (availableOptions.dimensionOverride != "fullscreen" && (originalWidth <= galleryWidth && originalHeight <= galleryHeight)) {
				// update image width
				imageWidth = originalWidth;
				// update image height
				imageHeight = originalHeight;
			}
			else {
				if (galleryWidth > galleryHeight) {
					if (originalWidth >= originalHeight) {
						// Set new height
						imageHeight = originalHeight * (galleryWidth / originalWidth);
					}
					else {
						// Set new Width
						imageWidth = originalWidth * (galleryHeight / originalHeight);
					}
				}
				else {
					if (originalWidth >= originalHeight) {
						// Set new height
						imageHeight = originalHeight * (galleryWidth / originalWidth);
					}
					else {
						// Set new width
						imageWidth = originalWidth * (galleryHeight / originalHeight);
					}
				}
				if (imageWidth > galleryWidth) {
					imageWidth = galleryWidth;
					imageHeight = originalHeight * (galleryWidth / originalWidth);
				}
				if (imageHeight > galleryHeight) {
					imageHeight = galleryHeight;
					imageWidth = originalWidth * (galleryHeight / originalHeight);
				}
			}
			// return width and height
			return [Math.ceil(imageWidth), Math.ceil(imageHeight)];
		};

		// Handle Image loading
		var imageLoaderSub = function(_img, _this) {
			// Establish reference to image id
			var imgId = _img;
			// check to see if image is already loaded
			if (!config.images[imgId].loaded) {
				// get reference to image container
				var imgSlot = d(uid + "_ImgSlot_" + imgId);
				// get reference to image
				var imgObject = d(uid + "_ImgImage_" + imgId);
				// check if resizing is needed
				if (availableOptions.dimensionOverride != "images") {
					// get adjusted image sizes
					var imageDimension = getAdjustedImageDimension(imgObject);
					// Update width and height
					imgObject.style.width = imageDimension[0] + "px";
					imgObject.style.height = imageDimension[1] + "px";
				}
				// update background
				imgSlot.style.backgroundImage = "none";
				// update background color if option was used
				if (config.images[imgId].hasOwnProperty("bgColor")) {
					imgSlot.style.backgroundColor = config.images[imgId].bgColor;
				}
				// show image
				imgObject.style.visibility = "visible";
				// check for widgets
				if (config.images[imgId].hasOwnProperty("widgets")) {
					// loop through widgets for image
					for (var j = 0; j < config.images[imgId].widgets.length; j++) {
						// add widget
						_this["Image" + imgId].addWidget(config.images[imgId].widgets[j]);
					}
				}
				// update loaded boolean
				config.images[imgId].loaded = true;
			}
		};

		// Handle image loading
		var imageLoader = function(_img, _this) {
			// listen for onload event
			d(uid + "_ImgImage_" + _img).addEventListener("load", function() {
				// handle on load event
				imageLoaderSub(_img, _this);
			}, false);
		};

		var buildImageGallery = function() {
			// create object to store images
			var _this = {};
			// Update Boolean
			proceeded = true;
			// Clear container div
			container.innerHTML = "";
			// Create New wrapper div
			var wrapper = document.createElement("div");
			wrapper.id = uid + "_ImageGallery";
			wrapper.style.width = galleryWidth + "px";
			wrapper.style.height = galleryHeight + "px";
			wrapper.style.position = "relative";
			wrapper.style.overflow = "hidden";
			container.appendChild(wrapper);
			// Create new mask div
			var masker = document.createElement("div");
			masker.id = uid + "_ImageGallerySub";
			masker.className = availableCSS[0];
			masker.style.width = galleryWidth + "px";
			masker.style.height = galleryHeight + "px";
			masker.style.overflow = "hidden";
			wrapper.appendChild(masker);
			// create new swipe div
			var swiper = document.createElement("div");
			swiper.id = uid + "_GalleryContainer";
			swiper.style.width = (galleryWidth * config.images.length) + "px";
			swiper.style.height = galleryHeight + "px";
			swiper.style.position = "relative";
			masker.appendChild(swiper);
			// create new indicator div
			var indicator = document.createElement("div");
			indicator.id = uid + "_ImgIndicator";
			indicator.className = availableCSS[5];
			indicator.style.display = availableOptions.showImageIndicator ? "block" : "none";
			wrapper.appendChild(indicator);
			// Create div for left nav
			var leftNav = document.createElement("div");
			leftNav.id = uid + "_NaviLeft";
			leftNav.className = availableCSS[3];
			leftNav.style.display = "none";
			leftNav.innerHTML = "<";
			wrapper.appendChild(leftNav);
			// Create div for right nav
			var rightNav = document.createElement("div");
			rightNav.id = uid + "_NaviRight";
			// Check if nav is needed
			if (config.images.length === 1) {
				// Hide right nav if not needed
				rightNav.style.display = availableOptions.showNavigationBar ? "block" : "none";
			}
			rightNav.className = availableCSS[4];
			rightNav.innerHTML = ">";
			wrapper.appendChild(rightNav);

			// add listeners
			leftNav.addEventListener("click", function(e) {
				stepToStop(e, 1);
			}, false);
			rightNav.addEventListener("click", function(e) {
				stepToStop(e, -1);
			}, false);

			// create new swipe navigator
			swipeNavigator = new VwSwipeNavigator(masker, swiper, 0 - (galleryWidth * (config.images.length + 1)), 0, galleryWidth, 0);

			// loop through images
			for (var i = 0; i < config.images.length; i++) {
				// create new div
				var slot = document.createElement("div");
				slot.id = uid + "_ImgSlot_" + i;
				slot.style.width = galleryWidth + "px";
				slot.style.height = galleryHeight + "px";
				slot.style.display = "inline-block";
				//slot.style.display = "block";
				slot.style.position = "relative";
				//slot.style.overflow = "hidden";
				slot.className = availableCSS[2];
				// Add to swiper
				swiper.appendChild(slot);

				// save image object
				_this["Image" + i] = slot;
				// add widget to image object
				_this["Image" + i].addWidget = function(widget) {
					// verifty that widget exists
					if (widget.hasOwnProperty("name") && widget.hasOwnProperty("content")) {
						// get image id
						var imgId = this.id.split("ImgSlot_")[1];
						// add widget reference to window
						window[widget.name] = addWidget(imgId, useTouchEvent ? widget.content.replace(/onClick/ig, "onTouchEnd") : widget.content);
					}
				};

				// update load status
				config.images[i].loaded = false;
				// check if smart loader is on
				if ((availableOptions.imageSmartLoader && i < 2) || !availableOptions.imageSmartLoader) {
					// update image container with image
					slot.innerHTML += getImageTag(i);
					// verify caption should be visible
					if (availableOptions.showImageCaption) {
						// show caption
						d(uid + "_ImgCaption_" + i).style.display = "block";
					}
					// load image
					imageLoader(i, _this);
				}
				// update swipe navigator
				swipeNavigator.addStop((0 - (galleryWidth * i)), 0);
				// verify indicator should be visible
				if (availableOptions.showImageIndicator) {
					// update indicator
					indicator.innerHTML += "<span id='" + uid + "_ImgInd_" + i + "' class='" + (i === 0 ? availableCSS[6] : availableCSS[7]) + "'>" + availableTemplates.indicator + "</span>";
				}
			}
			// check if images should be fullscreen
			if (availableOptions.dimensionOverride == "fullscreen") {
				// resize gallery
				resize();
				// add resize listener
				window.addEventListener('resize', resize, false);
			}

			// check if using nav
			if (availableOptions.showNavigationBar) {
				// update nav if necessary
				d(uid + "_NaviLeft").style.display = currentIndex === 0 ? "none" : "";
				d(uid + "_NaviRight").style.display = currentIndex == config.images.length - 1 ? "none" : "";
			}
			else {
				d(uid + "_NaviLeft").style.display = "none";
				d(uid + "_NaviRight").style.display = "none";
			}

			// Track first image load
			EB.automaticEventCounter("Image_Gallery_Navigated_To_0");

			// handle on complete event for swipe
			swipeNavigator.onNavigationComplete = function(e) {
				// verify move was horizontal
				if (e.axis == "x") {
					// get index
					var thisIdx = e.length - 1 - e.index;
					// check for change
					if (thisIdx != currentIndex) {
						// verify live ad
						if (!EB._isLocalMode) {
							// track
							EB.userActionCounter(availableOptions.eventNamePrefix + "_Navigated_To_" + thisIdx);
						}
						else {
							//console.log(ig.eventNamePrefix + "_Navigated_To_" + thisIdx);
						}
					}
					// update current index
					currentIndex = e.length - 1 - e.index;
					// check if using indicator
					if (availableOptions.showImageIndicator) {
						// update indicator
						for (i = 0; i < config.images.length; i++) {
							d(uid + "_ImgInd_" + i).className = (i == currentIndex ? availableCSS[6] : availableCSS[7]);
						}
					}

					// check if using nav
					if (availableOptions.showNavigationBar) {
						// update nav if necessary
						d(uid + "_NaviLeft").style.display = currentIndex === 0 ? "none" : "";
						d(uid + "_NaviRight").style.display = currentIndex == config.images.length - 1 ? "none" : "";
					}
					else {
						// Hide Navigation
						d(uid + "_NaviLeft").style.display = "none";
						d(uid + "_NaviRight").style.display = "none";
					}
					// check if we need to load new image
					for (i = (currentIndex === 0 ? currentIndex + 1 : currentIndex - 1); i < (currentIndex + 2 < config.images.length ? currentIndex + 2 : config.images.length); i++) {
						// check if image is loaded
						if (!config.images[i].loaded) {
							// load new image
							d(uid + "_ImgSlot_" + i).innerHTML += getImageTag(i);
							// check if captions are being used
							if (availableOptions.showImageCaption) {
								d(uid + "_ImgCaption_" + i).style.display = "block";
							}
							// start image loader
							imageLoader(i, _this);
						}
					}
				}
			};
		};

		// Return the current image index
		var getCurrentIndex = function() {
			return currentIndex;
		};

		// Return the current image info
		var getCurrentImage = function() {
			return config.images[currentIndex];
		};

		// show navigation arrows
		var showNavigation = function() {
			// update navigation styles
			d(uid + "_NaviLeft").style.visibility = "visible";
			d(uid + "_NaviRight").style.visibility = "visible";
		};

		// hide navigation arrows
		var hideNavigation = function() {
			// update nav styles
			d(uid + "_NaviLeft").style.visibility = "hidden";
			d(uid + "_NaviRight").style.visibility = "hidden";
		};

		// show indicator
		var showIndicator = function() {
			// update indicator style
			d(uid + "_ImgIndicator").style.visibility = "visible";
		};

		// hide indicator
		var hideIndicator = function() {
			// update indicator style
			d(uid + "_ImgIndicator").style.visibility = "hidden";
		};

		// show captions
		var showCaption = function() {
			// loop through all images
			for (var i = 0; i < config.images.length; i++) {
				// update caption style
				if (d(uid + "_ImgCaption_" + i)) {
					d(uid + "_ImgCaption_" + i).style.visibility = "visible";
				}
			}
		};

		// Hide captions
		var hideCaption = function() {
			// loop through all images
			for (var i = 0; i < config.images.length; i++) {
				// update caption style
				if (d(uid + "_ImgCaption_" + i)) {
					d(uid + "_ImgCaption_" + i).style.visibility = "hidden";
				}
			}
		};

		var _stepToStop = function(_step) {
			// determine which image we're moving to
			var _stop = config.images.length - 1 - currentIndex + _step;
			_stop = (_stop < 0 ? 0 : ((_stop > config.images.length - 1) ? config.images.length - 1 : _stop));
			// Update swipe
			swipeNavigator.navigateToStop(_stop, "x");
		};

		var goToNextImage = function() {
			// move to next image
			_stepToStop(-1);
		};

		var goToPreviousImage = function() {
			// move to previous image
			_stepToStop(1);
		};

		var goToImage = function(_idx) {
			// determine how many images we're moving
			var step = currentIndex >= _idx ? currentIndex - _idx : 0 - (_idx - currentIndex);
			// move to image
			if (step !== 0) {
				_stepToStop(step);
			}
		};

		// Handle navigation
		var stepToStop = function(_obj, _step) {
			// verify we're targeting the correct gallery
			if (_obj.target.id.split("_")[0] === uid) {
				// move to image
				_stepToStop(_step);
			}
		};

		var clickThrough = function() {
			var clickThruName = availableOptions.eventNamePrefix + "_ClickThrough_" + currentIndex;
			if (EB._isLocalMode) {
				// console.log(clickThruName);
				// console.log("Click through does not work in local mode");
			}
			else {
				if (EB._adConfig.interactions.hasOwnProperty(clickThruName)) {
					var clickThruObject = EB._adConfig.interactions[clickThruName];
					if (clickThruObject.jumpUrl !== "") {
						EB.clickthrough(clickThruName);
					}
				}
			}
		};

		// Add Widget to image
		var addWidget = function(_img, _widget) {
			// Get reference to image container
			var parent = d(uid + "_ImgSlot_" + _img);
			// add widget content to parent content
			parent.innerHTML += _widget;
			// add widget to end of content
			_widget = parent.lastChild;
			// update widget id
			if (!_widget.id) {
				_widget.id = uid + "_Img" + _img + "Widget" + Math.floor(Math.random() * 10000);
			}
			return {
				parent: parent,
				widget: _widget,
				getId: function() {
					return _widget.id;
				},
				show: function() {
					_widget.style.display = "";
				},
				hide: function() {
					_widget.style.display = "none";
				},
				moveTo: function(x, y) {
					_widget.style.top = y + "px";
					_widget.style.left = x + "px";
				},
				remove: function() {
					parent.removeChild(_widget);
				}
			};
		};

		// refresh Image Gallery
		var refresh = function() {
			buildImageGallery();
		};

		// Resize image gallery
		var resize = function(_width, _height) {
			// Establish var for width and height
			var toWidth, toHeight;
			// Check if supplied with width and height
			if (arguments.length !== 2) {
				// update width
				toWidth = window.innerWidth;
				// update height
				toHeight = window.innerHeight;
				// Check if already in fullscreen mode
				if (availableOptions.dimensionOverride !== "fullscreen") {
					// update option
					availableOptions.dimensionOverride = "fullscreen";
					// add resize listener
					window.addEventListener('resize', resize, false);
				}
			}
			else {
				// update option
				availableOptions.dimensionOverride = "none";
				// remove resize listener
				window.removeEventListener('resize', resize, false);
				// update width and height
				toWidth = _width;
				toHeight = _height;
			}
			// If no change in height and width, stop
			if (galleryWidth == toWidth && galleryHeight == toHeight) {
				return false;
			}
			// Update Gallery width
			galleryWidth = toWidth;
			// Update Gallery height
			galleryHeight = toHeight;
			// get reference to image wrapper div
			var galleryObj = d(uid + "_ImageGallery");
			// get reference to sub wrapper div
			var galleryStage = d(uid + "_ImageGallerySub");
			// get reference to swiper div
			var gallerySwiper = d(uid + "_GalleryContainer");
			// update div width
			galleryObj.style.width = galleryWidth + "px";
			galleryStage.style.width = galleryWidth + "px";
			gallerySwiper.style.width = (config.images.length * galleryWidth) + "px";
			// update div height
			galleryObj.style.height = galleryHeight + "px";
			galleryStage.style.height = galleryHeight + "px";
			gallerySwiper.style.height = galleryHeight + "px";
			// reset swipe navigator
			swipeNavigator.clearStops();
			swipeNavigator.minX = 0 - (config.images.length * galleryWidth);
			swipeNavigator.maxX = galleryWidth;
			swipeNavigator.positionOnXAxis = (0 - (currentIndex * galleryWidth));

			// loop through images
			for (var j = 0; j < config.images.length; j++) {
				// Get reference to image container
				var imageSlot = d(uid + "_ImgSlot_" + j);
				// Update swipe navigator
				swipeNavigator.addStop(0 - (galleryWidth * j), 0);
				//update width & height
				imageSlot.style.width = galleryWidth + "px";
				imageSlot.style.height = galleryHeight + "px";
				// verify image exists
				if (d(uid + "_ImgImage_" + j)) {
					// get image reference
					var imgObject = d(uid + "_ImgImage_" + j);
					// get updated image sizes
					var imageDimension = getAdjustedImageDimension(imgObject);
					// update image width & height
					imgObject.style.width = imageDimension[0] + "px";
					imgObject.style.height = imageDimension[1] + "px";
					// update max width
					d(uid + "_ImgCaption_" + j).style.maxWidth = galleryWidth + "px";
				}
			}
			// update swiper location
			gallerySwiper.style.left = (0 - (currentIndex * galleryWidth)) + "px";
		};

		// Dom utilities code
		var getEquivalentDeviceInputFromTouch = function(typ) {
			switch (typ) {
				case "touchstart":
					return "mousedown";
				case "touchmove":
					return "mousemove";
				case "touchend":
					return "mouseup";
				default:
					return typ;
			}
			return typ;
		};

		var getPointerPosition = function(e) {
			var _pointerPosition = {
				x: 0,
				y: 0
			};
			if (e.targetTouches) {
				_pointerPosition.x = e.targetTouches[0].clientX;
				_pointerPosition.y = e.targetTouches[0].clientY;
			}
			else if (e.changedTouches) {
				_pointerPosition.x = e.changedTouches[0].pageX;
				_pointerPosition.y = e.changedTouches[0].pageY;
			}
			else if (e.pageX) {
				_pointerPosition.x = e.pageX;
				_pointerPosition.y = e.pageY;
			}
			else if (e.clientX) {
				_pointerPosition.x = e.clientX;
				_pointerPosition.y = e.clientY;
			}

			return _pointerPosition;
		};

		var getCurrentStyle = function(_elem, _style) {
			var _value = null;
			if (typeof window.getComputedStyle != "undefined") {
				_value = parseInt(window.getComputedStyle(_elem).getPropertyValue(_style));
			}
			else {
				_value = parseInt(_elem.currentStyle[_style]);
			}
			return _value;
		};

		/// vwTouchArea code
		var VwTouchArea = function(_target) {
			if (!Array.indexOf) {
				Array.prototype.indexOf = function(obj) {
					for (var i = 0; i < this.length; i++) {
						if (this[i] == obj) {
							return i;
						}
					}
					return -1;
				};
			}
			this.target = _target;
			this._isEnabled = false;
			this.enableInput();
			this.mouseIsDown = this.isActive = false;
			this.startPositionOnXAxis = null;
			this.startPositionOnYAxis = null;
			this.startTime = new Date();
			this.timeout = 2000;
			this._listeners = [];
			this._disabledListeners = [];
			this.iemousedown = null;
			this.iemousemove = null;
			this.iemouseup = null;
			this.autoEndTimeout = null;
		};

		VwTouchArea.prototype.handleEvent = function(e, self) {
			if (!e) e = window.e;
			if (!self) self = this;
			switch (e.type) {
				case "touchstart":
					self.onTouchStart(e);
					break;
				case "touchmove":
					self.onTouchMove(e);
					break;
				case "touchend":
					self.onTouchEnd(e);
					break;
				case "mousedown":
					self.onTouchStart(e);
					break;
				case "mousemove":
					self.onTouchMove(e);
					break;
				case "mouseup":
					self.onTouchEnd(e);
					break;
				case "mouseout":
					var from = e.relatedTarget || e.toElement;
					if (!from || from.nodeName == "HTML") {
						//MMTrace(e.currentTarget + "mouse out");
						self.onTouchEnd(e);
					}
					break;
			}
		};

		VwTouchArea.prototype.processEvent = function(e) {
			if (!isIE) {
				e.preventDefault();
			}
			else {
				if (event !== null) {
					event.returnValue = false;
				}
			}
			return (e);
		};

		VwTouchArea.prototype.enableInput = function() {
			if (!this._isEnabled) {
				this.addTouchListener(this.target, "touchstart", false);
				this._listeners = this._disabledListeners;
				this._isEnabled = true;
			}
		};

		VwTouchArea.prototype.onTouchStart = function(e) {
			window.clearTimeout(this.autoEndTimeout);
			this.isActive = true;
			e = this.processEvent(e);
			if (supportsTouch && e.targetTouches) {
				if (e.targetTouches.length != 1 && VwTrackedObjectCount > 0) {
					return false;
				}
				VwTrackedObjectCount++;
			}
			else {
				this.mouseIsDown = true;
			}
			this.lastPointerPosition = this.currentPointerPostion = window._pointerPosition = getPointerPosition(e);
			this.startPositionOnXAxis = _pointerPosition.x;
			this.startPositionOnYAxis = _pointerPosition.y;
			this.startTime = new Date();
			this.registerTouches();
			this.broadcastMessage("touchStart", {
				target: this,
				type: 'touchStart',
				touchX: this.startPositionOnXAxis,
				touchY: this.startPositionOnYAxis,
				time: this.startTime.getTime()
			});
			return false;
		};

		VwTouchArea.prototype.onTouchMove = function(e) {
			window.clearTimeout(this.autoEndTimeout);
			if (supportsTouch || this.mouseIsDown) {
				e = this.processEvent(e);
				var _newPointerPosition = getPointerPosition(e);
				var _windowLeft = window.screenX;
				var _windowTop = window.screenY;
				var _windowRight = window.screenX + window.innerWidth;
				var _windowBottom = window.screenY + window.innerHeight;
				var _xPositionOffset = _newPointerPosition.x - this.startPositionOnXAxis;
				var _yPositionOffset = _newPointerPosition.y - this.startPositionOnYAxis;
				if (supportsTouch && e.targetTouches) {
					if (e.targetTouches.length != 1) {
						return false;
					}
				}
				var self = this;
				this.autoEndTimeout = window.setTimeout(function() {
					self.onTouchEnd(e);
				}, this.timeout);
				var _newTime = new Date();
				var _timeOffset = parseInt(_newTime.getTime()) - parseInt(this.startTime.getTime());
				this.broadcastMessage("touchMove", {
					target: this,
					type: 'touchMove',
					touchX: _newPointerPosition.x,
					touchY: _newPointerPosition.y,
					xOffset: _xPositionOffset,
					yOffset: _yPositionOffset,
					time: _newTime.getTime()
				});
				this.startPositionOnXAxis = _newPointerPosition.x;
				this.startPositionOnYAxis = _newPointerPosition.y;
				this.startTime = _newTime;
				return false;
			}
		};

		VwTouchArea.prototype.onTouchEnd = function(e) {
			window.clearTimeout(this.autoEndTimeout);
			this.isActive = false;
			this.broadcastMessage("touchEnd", {
				target: this,
				type: 'touchEnd'
			});
			e = this.processEvent(e);
			if (supportsTouch && e.targetTouches) {
				if (e.targetTouches.length > 0) {
					this.resetToTouch(e.targetTouches[0]);
				}
			}
			else {
				this.mouseIsDown = false;
			}
			this.unregisterTouches();
			return false;
		};

		VwTouchArea.prototype.resetToTouch = function(aTouch) {
			this.startPositionOnXAxis = aTouch.clientX;
			this.startPositionOnYAxis = aTouch.clientY;
		};

		VwTouchArea.prototype.registerTouches = function() {
			this.addTouchListener(window, "touchmove", false);
			this.addTouchListener(window, "touchend", false);
			this.addTouchListener(document, "mouseout", false);
		};

		VwTouchArea.prototype.unregisterTouches = function() {
			this.removeTouchListener(window, "touchmove", false);
			this.removeTouchListener(window, "touchend", false);
			this.removeTouchListener(document, "mouseout", false);
		};
		VwTouchArea.prototype.addTouchListener = function(_target, _type, _bubbles) {
			var _touchArea = this;
			if (!_bubbles) {
				_bubbles = false;
			}
			if (!isIE || browserVersion >= 9) {
				_target.addEventListener(_type, _touchArea, _bubbles);
				if (_type === "touchstart" || _type === "touchmove" || _type === "touchend") {
					_type = getEquivalentDeviceInputFromTouch(_type);
					_target.addEventListener(_type, _touchArea, _bubbles);
				}
			}
			else {
				if (_target == window) {
					_target = document.body;
				}
				this["ie" + _type] = function() {
					_touchArea.handleEvent(window.event, _touchArea);
				};
				_target.attachEvent("on" + _type, this["ie" + _type]);
				if (_type === "touchstart" || _type === "touchmove" || _type === "touchend") {
					_type = getEquivalentDeviceInputFromTouch(_type);
					_target.attachEvent("on" + _type, this["ie" + _type]);
				}
			}
		};

		VwTouchArea.prototype.removeTouchListener = function(_target, _type, _bubbles) {
			var _touchArea = this;
			if (!_bubbles) {
				_bubbles = false;
			}
			if (!!isIE || browserVersion >= 9) {
				_target.removeEventListener(_type, _touchArea, _bubbles);
				if (_type === "touchstart" || _type === "touchmove" || _type === "touchend") {
					_type = getEquivalentDeviceInputFromTouch(_type);
					_target.removeEventListener(_type, _touchArea, _bubbles);
				}
			}
			else {
				if (_target == window) {
					_target = document.body;
				}
				if (_type === "touchstart" || _type === "touchmove" || _type === "touchend") {
					_type = getEquivalentDeviceInputFromTouch(_type);
					_target.detachEvent("on" + _type, this["ie" + _type]);
				}
			}
		};

		VwTouchArea.prototype.addListener = function(o) {
			this.removeListener(o);
			return this._listeners.push(o);
		};

		VwTouchArea.prototype.removeListener = function(o) {
			var a = this._listeners;
			var i = a.length;
			while (i--) {
				if (a[i] == o) {
					a.splice(i, 1);
					return true;
				}
			}
			return false;
		};

		VwTouchArea.prototype.broadcastMessage = function() {
			var arr = [];
			for (var i = 0; i < arguments.length; i++) {
				arr.push(arguments[i]);
			}
			var e = arr.shift();
			var a = this._listeners;
			var l = a.length;
			for (i = 0; i < l; i++) {
				if (a[i][e])
					a[i][e].apply(a[i], arr);
			}
		};

		// Swipe Navigator code
		var VwSwipeNavigator = function(_viewer, _content, _minX, _minY, _maxX, _maxY) {
			if (_viewer != "null") {
				this.touchArea = new VwTouchArea(_viewer);
				this.touchArea.timeout = 500;
				this.touchArea.addListener(this);
			}
			this.content = _content;
			this.minX = _minX;
			this.maxX = _maxX;
			this.minY = _minY;
			this.maxY = _maxY;
			this.positionOnXAxis = 0;
			this.positionOnYAxis = 0;
			this.xStops = [];
			this.yStops = [];
			this.xStopIndex = 0;
			this.yStopIndex = 0;
			this.currentTouchTime = 0;
			this.currentXTouchOffset = 0;
			this.lastYTouchOffset = 0;
			this.lastTouchTime = 0;
			this.lastXTouchOffset = 0;
			this.lastYTouchOffset = 0;
			this.startPositionOnXAxis = 0;
			this.startPositionOnYAxis = 0;
			this.savedPositionsOnXAxis = [];
			this.savedPositionsOnYAxis = [];
			this.startTouchTime = 0;
			this.savePositionInt = 0;
			this.xSpeed = 0;
			this.ySpeed = 0;
			this.xTween = null;
			this.yTween = null;
			this.rightButton = null;
			this.leftButton = null;
			this.upButton = null;
			this.downButton = null;
			this._listeners = [];
			this.addListener(this);
			var _self = this;
			this.iemousedown = null;
			this.iemousemove = null;
			this.iemouseup = null;

			window.setInterval(function() {
				_self.savePosition();
			}, 1);
		};

		VwSwipeNavigator.prototype.touchStart = function(e) {
			this.lastTouchTime = 0;
			this.lastTouchOffset = 1;
			this.startPositionOnXAxis = this.positionOnXAxis;
			this.savedPositionsOnXAxis = [];
			this.startPositionOnYAxis = this.positionOnYAxis;
			this.savedPositionsOnYAxis = [];

			this.lastXTouchOffset = this.currentXTouchOffset = this.totalXTouchOffset = 0;
			this.lastYTouchOffset = this.currentYTouchOffset = this.totalYTouchOffset = 0;
			this.broadcastMessage('onNavigationStart', {
				target: this,
				type: 'onNavigationStart'
			});
			this.startTouchTime = e.time;
			this.clearTween(this.xTween);
			this.clearTween(this.yTween);
			var _self = this;
		};

		VwSwipeNavigator.prototype.touchMove = function(e) {
			this.positionOnXAxis = this.getComponent(this.minX, this.maxX, parseInt(this.positionOnXAxis + e.xOffset));
			this.positionOnYAxis = this.getComponent(this.minY, this.maxY, parseInt(this.positionOnYAxis + e.yOffset));
			this.lastXTouchOffset = this.currentXTouchOffset;
			this.lastYTouchOffset = this.currentYTouchOffset;
			this.currentXTouchOffset = e.xOffset;
			this.currentYTouchOffset = e.yOffset;
			this.currentTouchTime = e.time;
			this.lastTouchTime = this.currentTouchTime;
			this.xSpeed = (this.positionOnXAxis - this.savedPositionsOnXAxis[this.savedPositionsOnXAxis.length - 1]) / ((this.currentTouchTime - this.startTouchTime) / 1000);
			this.ySpeed = (this.positionOnYAxis - this.savedPositionsOnYAxis[this.savedPositionsOnYAxis.length - 1]) / ((this.currentTouchTime - this.startTouchTime) / 1000);
			this.broadcastMessage('onNavigationMove', {
				target: this,
				type: 'onNavigationMove',
				speed: this.xSpeed,
				axis: "x"
			});
			this.broadcastMessage('onNavigationMove', {
				target: this,
				type: 'onNavigationMove',
				speed: this.xSpeed,
				axis: "y"
			});
			this.content.style.left = this.positionOnXAxis + "px";
			this.content.style.top = this.positionOnYAxis + "px";
			if (isWebkit) {
				this.content.style.webkitTransform = 'scale(1)';
			}
		};

		VwSwipeNavigator.prototype.savePosition = function() {
			this.savedPositionsOnXAxis.unshift(this.positionOnXAxis);
			if (this.savedPositionsOnXAxis.length > 10) {
				this.savedPositionsOnXAxis = this.savedPositionsOnXAxis.slice(0, 10);
			}
			this.savedPositionsOnYAxis.unshift(this.positionOnYAxis);
			if (this.savedPositionsOnYAxis.length > 10) {
				this.savedPositionsOnYAxis = this.savedPositionsOnYAxis.slice(0, 10);
			}
		};

		VwSwipeNavigator.prototype.touchEnd = function(e) {
			clearInterval(this.savePositionInt);
			this.xSpeed = (this.positionOnXAxis - this.savedPositionsOnXAxis[this.savedPositionsOnXAxis.length - 1]) / ((this.currentTouchTime - this.startTouchTime) / 1000);
			this.ySpeed = (this.positionOnYAxis - this.savedPositionsOnYAxis[this.savedPositionsOnYAxis.length - 1]) / ((this.currentTouchTime - this.startTouchTime) / 1000);
			this.gotoNearestStop(this.positionOnXAxis, this.positionOnYAxis);
		};

		VwSwipeNavigator.prototype.addStopFromElement = function(_elem) {
			var _x = (_elem.style.left) ? parseInt(_elem.style.left) * -1 : 0;
			var _y = (_elem.style.top) ? parseInt(_elem.style.top) * -1 : 0;
			this.addStop(_x, _y);
		};

		VwSwipeNavigator.prototype.addStop = function(_x, _y, _id) {
			var _stopX = this.getComponent(this.minX, this.maxX, _x);
			var _stopY = this.getComponent(this.minY, this.maxY, _y);
			if (this.xStops.indexOf(_stopX) == -1) {
				this.xStops.push(_stopX);
				this.xStops.sort(function(a, b) {
					return a - b;
				});
			}
			if (this.yStops.indexOf(_stopY) == -1) {
				this.yStops.push(_stopY);
				this.yStops.sort(function(a, b) {
					return a - b;
				});
			}
			this.xStopIndex = this.xStops.length - 1;
			this.yStopIndex = this.yStops.length - 1;
		};

		VwSwipeNavigator.prototype.removeStop = function(_x, _y, _id) {

			var _stopX = this.getComponent(this.minX, this.maxX, _x);
			var _stopY = this.getComponent(this.minY, this.maxY, _y);
			if (this.xStops.indexOf(_stopX) != -1) {
				this.xStops.splice(this.xStops.indexOf(_stopX), 1);
			}
			if (this.yStops.indexOf(_stopY) != -1) {
				this.yStops.splice(this.xStops.indexOf(_stopY), 1);
			}
		};

		VwSwipeNavigator.prototype.clearStops = function() {
			this.xStops = [];
			this.yStops = [];
		};

		VwSwipeNavigator.prototype.handleEvent = function(event, self) {
			if (!event) event = window.event;
			if (!self) self = this;
			switch (event.type) {
				case "touchstart":
					event.stopPropagation();
					break;
				case "touchend":
					self.navigateFromCurrentStop(_distance, _axis);
					break;
				case "mousedown":
					event.stopPropagation();
					break;
				case "mouseup":
					self.navigateFromCurrentStop(_distance, _axis);
					break;
			}
		};

		VwSwipeNavigator.prototype.navigateFromCurrentStop = function(_distance, _axis) {
			this.clearTween(this.xTween);
			this.clearTween(this.yTween);
			if (!_axis) {
				_axis = "x";
			}
			var _arr = (_axis == "y") ? this.yStops : this.xStops;
			var _position = (_axis == "y") ? this.positionOnYAxis : this.positionOnXAxis;
			var _currentIndex = _arr.indexOf(_position);
			var _newIndex = _currentIndex + _distance;
			var _destination = _position;
			if (_newIndex >= 0 && _newIndex < _arr.length) {
				_destination = _arr[_newIndex];
				this.navigateToPosition(_destination, _axis);
			}
		};

		VwSwipeNavigator.prototype.navigateToStop = function(_stopIndex, _axis) {
			var _arr = (_axis == "y") ? this.yStops : this.xStops;
			var _position = (_axis == "y") ? this.positionOnYAxis : this.positionOnXAxis;
			var _destination = _arr[_stopIndex];
			this.navigateToPosition(_destination, _axis);
		};

		VwSwipeNavigator.prototype.navigateToPosition = function(_destination, _axis, _duration, _easetype) {
			if (!_duration) {
				_duration = 0.6;
			}
			if (!_easetype) {
				_easetype = "strongEaseOut";
			}
			if (_axis == "x") {
				this.clearTween(this.xTween);
				this.xTween = new VwTween(this.content.style, "left", VwTween[_easetype], this.positionOnXAxis, _destination, _duration, "px");
				this.xTween.addListener(this);
				this.xTween.start();
				this.positionOnXAxis = _destination;
			}
			else {
				this.clearTween(this.yTween);
				this.yTween = new VwTween(this.content.style, "top", VwTween[_easetype], this.positionOnYAxis, _destination, _duration, "px");
				this.yTween.addListener(this);
				this.yTween.start();
				this.positionOnYAxis = _destination;
			}
		};

		VwSwipeNavigator.prototype.easeOut = function() {
			if (isFinite(this.xSpeed) && !isNaN(this.xSpeed) && this.xSpeed !== 0) {
				var _xDuration = 2;
				var _xDestination = 0;
				var _currentSpeed = Math.abs(this.xSpeed);
				var _direction = (this.xSpeed < 0) ? -1 : 1;
				var _divisor = 2;
				for (var _s = 0; _s < 10000; ++_s) {
					_xDestination = _xDestination + _currentSpeed * _direction;
					_currentSpeed = _currentSpeed / 4;
					_divisor += 1;
					if (_currentSpeed < 1) {
						break;
					}
				}
				_xDestination = (Math.abs(_xDestination) > 400) ? 400 * _direction : _xDestination;
				_xDestination = this.positionOnXAxis + _xDestination;
				_xDestination = this.getComponent(this.minX, this.maxX, _xDestination);
				this.navigateToPosition(_xDestination, "x", _xDuration, "strongEaseOut");
			}
			else {
				this.completeNavigation("x", this.xStops.indexOf(this.positionOnXAxis), this.xStops.length);
			}
			if (isFinite(this.ySpeed) && !isNaN(this.ySpeed) && this.ySpeed !== 0) {
				var _yDuration = 2;
				var _yDestination = 0;
				var _currentYSpeed = Math.abs(this.ySpeed);
				var _yDirection = (this.ySpeed < 0) ? -1 : 1;
				for (var _sY = 0; _sY < 10000; ++_sY) {
					_yDestination = _yDestination + _currentYSpeed * _yDirection;
					_currentYSpeed = _currentYSpeed / 4;
					if (_currentYSpeed < 1) {
						break;
					}
				}
				_yDestination = (Math.abs(_yDestination) > 400) ? 400 * _yDirection : _yDestination;
				_yDestination = this.positionOnYAxis + _yDestination;
				_yDestination = this.getComponent(this.minY, this.maxY, _yDestination);

				this.navigateToPosition(_yDestination, "y", _yDuration, "strongEaseOut");
			}
			else {
				this.completeNavigation("y", this.yStops.indexOf(this.positionOnYAxis), this.yStops.length);
			}
		};

		VwSwipeNavigator.prototype.gotoNearestStop = function(_x, _y) {
			var _yspeed = this.lastYTouchOffset / this.lastTouchTime;
			var _destinationXStop = this.getDestinationStop(_x, this.xStops, this.xSpeed);
			var _destinationYStop = this.getDestinationStop(_y, this.yStops, this.ySpeed);
			var _xDistance = Math.abs(_destinationXStop - this.positionOnXAxis);
			var _xDuration = (_xDistance * this.lastTouchTime) / Math.abs(this.lastXTouchOffset) / 1000;
			var _yDistance = Math.abs(_destinationYStop - this.positionOnYAxis);
			var _yDuration = (_yDistance * this.lastTouchTime) / Math.abs(this.lastYTouchOffset) / 1000;
			_xDuration = this.getComponent(0.3, 1.5, _xDuration);
			_yDuration = this.getComponent(0.3, 1.5, _yDuration);
			var _self = this;
			if (_destinationXStop !== null && _destinationXStop != this.positionOnXAxis) {
				this.navigateToPosition(_destinationXStop, "x");
			}
			else {
				this.completeNavigation("x", this.xStops.indexOf(this.positionOnXAxis), this.xStops.length);
			}
			if (_destinationYStop !== null && _destinationYStop != this.positionOnYAxis) {
				this.navigateToPosition(_destinationYStop, "y");
			}
			else {
				this.completeNavigation("y", this.yStops.indexOf(this.positionOnYAxis), this.yStops.length);
			}
		};

		VwSwipeNavigator.prototype.getDestinationStop = function(_pos, _arr, _speed) {
			var _stops = {
				previous: null,
				next: null
			};
			var _destination = null;
			if (_pos > _arr[_arr.length - 1]) {
				_destination = _arr[_arr.length - 1];
			}
			if (_pos < _arr[0]) {
				_destination = _arr[0];
			}
			if (_arr.indexOf[_pos] >= 0) {
				_destination = _pos;
			}
			if (_destination === null) {
				for (var _stop = 0; _stop < _arr.length; _stop++) {
					if (_pos > _arr[_stop]) {
						_stops.previous = _arr[_stop];
						if ((_stop + 1) < _arr.length) {
							_stops.next = _arr[_stop + 1];
						}
					}
				}
				var _closestStop = _stops.previous;
				if (_stops.next !== null) {
					_closestStop = ((_pos - _stops.previous) <= (_stops.next - _pos)) ? _stops.previous : _stops.next;
				}
				if (_speed > 0.2 && _stops.next !== null) {
					_destination = _stops.next;
				}
				else if (_speed < -0.2 && _stops.previous !== null) {
					_destination = _stops.previous;
				}
				else {
					_destination = _closestStop;
				}
			}
			return _destination;
		};

		VwSwipeNavigator.prototype.onMotionFinished = function(e) {
			var _axis;
			var _index;
			var _length;
			var _self = this;
			if (e.target == this.xTween) {
				_axis = "x";
				_index = this.xStops.indexOf(this.positionOnXAxis);
				_length = this.xStops.length;
			}
			else {
				_axis = "y";
				_index = this.yStops.indexOf(this.positionOnYAxis);
				_length = this.yStops.length;
			}
			if (isWebkit) {
				this.content.style.webkitTransform = 'scale(1)';
				//this.content.offsetHeight;
				this.content.style.webkitTransform = 'none';
			}
			this.completeNavigation(_axis, _index, _length);
		};

		VwSwipeNavigator.prototype.onMotionChanged = function(e) {
			if (e.target == this.xTween) {
				this.positionOnXAxis = e.target._pos;
				this.broadcastMessage('onNavigationMove', {
					target: this,
					type: 'onNavigationMove',
					speed: this.xSpeed,
					axis: "x"
				});
			}
			if (e.target == this.yTween) {
				this.positionOnYAxis = e.target._pos;
				this.broadcastMessage('onNavigationMove', {
					target: this,
					type: 'onNavigationMove',
					speed: this.ySpeed,
					axis: "y"
				});
			}
		};

		VwSwipeNavigator.prototype.clearTween = function(_twn) {
			if (_twn !== null) {
				_twn.stop();
			}
		};

		VwSwipeNavigator.prototype.completeNavigation = function(_axis, _index, _length) {
			this[_axis + "StopIndex"] = _index;
			this.broadcastMessage('onNavigationComplete', {
				target: this,
				type: 'onNavigationComplete',
				axis: _axis,
				index: _index,
				length: _length
			});
		};

		VwSwipeNavigator.prototype.addListener = function(o) {
			this.removeListener(o);
			return this._listeners.push(o);
		};

		VwSwipeNavigator.prototype.removeListener = function(o) {
			var a = this._listeners;
			var i = a.length;
			while (i--) {
				if (a[i] == o) {
					a.splice(i, 1);
					return true;
				}
			}
			return false;
		};

		VwSwipeNavigator.prototype.broadcastMessage = function() {
			var arr = [];
			for (var i = 0; i < arguments.length; i++) {
				arr.push(arguments[i]);
			}
			var e = arr.shift();
			var a = this._listeners;
			var l = a.length;
			for (i = 0; i < l; i++) {
				if (a[i][e])
					a[i][e].apply(a[i], arr);
			}
		};

		VwSwipeNavigator.prototype.getComponent = function(low, high, target) {
			if (low > target) {
				return low;
			}
			else if (target > high) {
				return high;
			}
			else {
				return target;
			}
			return 0;
		};

		// vwteen code
		window.VwTouchArea = VwTouchArea;

		window.VwTwnDelegate.create = function(o, f) {
			var a = [];
			var l = arguments.length;
			for (var i = 2; i < l; i++) a[i - 2] = arguments[i];
			return function() {
				var aP = [].concat(arguments, a);
				f.apply(o, aP);
			};
		};

		VwTween = function(obj, prop, func, begin, finish, duration, suffixe) {
			this.init(obj, prop, func, begin, finish, duration, suffixe);
		};

		VwTwnInst = VwTween.prototype;

		VwTwnInst.obj = {};
		VwTwnInst.prop = '';
		VwTwnInst.func = function(t, b, c, d) {
			return c * t / d + b;
		};
		VwTwnInst.begin = 0;
		VwTwnInst.change = 0;
		VwTwnInst.prevTime = 0;
		VwTwnInst.prevPos = 0;
		VwTwnInst.looping = false;
		VwTwnInst._duration = 0;
		VwTwnInst._time = 0;
		VwTwnInst._pos = 0;
		VwTwnInst._position = 0;
		VwTwnInst._startTime = 0;
		VwTwnInst._finish = 0;
		VwTwnInst.name = '';
		VwTwnInst.suffixe = '';
		VwTwnInst._listeners = [];
		VwTwnInst.setTime = function(t) {
			this.prevTime = this._time;
			if (t > this.getDuration()) {
				if (this.looping) {
					this.rewind(t - this._duration);
					this.update();
					this.broadcastMessage('onMotionLooped', {
						target: this,
						type: 'onMotionLooped'
					});
				}
				else {
					this._time = this._duration;
					this.update();
					this.stop();
					this.broadcastMessage('onMotionFinished', {
						target: this,
						type: 'onMotionFinished'
					});
				}
			}
			else if (t < 0) {
				this.rewind();
				this.update();
			}
			else {
				this._time = t;
				this.update();
			}
		};

		VwTwnInst.getTime = function() {
			return this._time;
		};

		VwTwnInst.setDuration = function(d) {
			this._duration = (d == null || d <= 0) ? 100000 : d;
		};

		VwTwnInst.getDuration = function() {
			return this._duration;
		};

		VwTwnInst.setPosition = function(p) {
			this.prevPos = this._pos;
			var a = this.suffixe != '' ? this.suffixe : '';
			this.obj[this.prop] = Math.round(p) + a;
			this._pos = p;
			this.broadcastMessage('onMotionChanged', {
				target: this,
				type: 'onMotionChanged'
			});
		};

		VwTwnInst.getPosition = function(t) {
			if (t == undefined) t = this._time;
			return this.func(t, this.begin, this.change, this._duration);
		};

		VwTwnInst.setFinish = function(f) {
			this.change = f - this.begin;
		};

		VwTwnInst.init = function(obj, prop, func, begin, finish, duration, suffixe) {
			if (!arguments.length) return;
			this._listeners = [];
			this.addListener(this);
			if (suffixe) this.suffixe = suffixe;
			this.obj = obj;
			this.prop = prop;
			this.begin = begin;
			this._pos = begin;
			this.setDuration(duration);
			if (func != null && func != '') {
				this.func = func;
			}
			this.setFinish(finish);
		};

		VwTwnInst.start = function() {
			this.rewind();
			this.startEnterFrame();
			this.broadcastMessage('onMotionStarted', {
				target: this,
				type: 'onMotionStarted'
			});
		};

		VwTwnInst.rewind = function(t) {
			this.stop();
			this._time = (t == undefined) ? 0 : t;
			this.fixTime();
			this.update();
		};

		VwTwnInst.update = function() {
			this.setPosition(this.getPosition(this._time));
		};

		VwTwnInst.startEnterFrame = function() {
			this.stopEnterFrame();
			this.isPlaying = true;
			this.onEnterFrame();
		};

		VwTwnInst.onEnterFrame = function() {
			if (this.isPlaying) {
				this.nextFrame();
				setTimeout(VwTwnDelegate.create(this, this.onEnterFrame), 0);
			}
		};

		VwTwnInst.nextFrame = function() {
			this.setTime((this.getTimer() - this._startTime) / 1000);
		};

		VwTwnInst.stop = function() {
			this.stopEnterFrame();
			this.broadcastMessage('onMotionStopped', {
				target: this,
				type: 'onMotionStopped'
			});
		};

		VwTwnInst.stopEnterFrame = function() {
			this.isPlaying = false;
		};

		VwTwnInst.continueTo = function(finish, duration) {
			this.begin = this._pos;
			this.setFinish(finish);
			if (this._duration != undefined)
				this.setDuration(duration);
			this.start();
		};

		VwTwnInst.addListener = function(o) {
			this.removeListener(o);
			return this._listeners.push(o);
		};

		VwTwnInst.removeListener = function(o) {
			var a = this._listeners;
			var i = a.length;
			while (i--) {
				if (a[i] == o) {
					a.splice(i, 1);
					return true;
				}
			}
			return false;
		};

		VwTwnInst.broadcastMessage = function() {
			var arr = [];
			for (var i = 0; i < arguments.length; i++) {
				arr.push(arguments[i]);
			}
			var e = arr.shift();
			var a = this._listeners;
			var l = a.length;
			for (i = 0; i < l; i++) {
				if (a[i][e])
					a[i][e].apply(a[i], arr);
			}
		};

		VwTwnInst.fixTime = function() {
			this._startTime = this.getTimer() - this._time * 1000;
		};

		VwTwnInst.getTimer = function() {
			return new Date().getTime() - this._time;
		};

		VwTween.strongEaseOut = function(t, b, c, d) {
			return c * ((t = t / d - 1) * t * t * t * t + 1) + b;
		};

		// DO NOT REMOVE THE FOLLOWING
		//=================================================
		// Utility Functions
		//-------------------------------------------------

		// Debugging
		var log = function() { // this is a closure-compiled version of the original code
			if (isDebug) {
				var b, a;
				b = Array.prototype.slice.call(arguments);
				a = new Date();
				a = scriptName + " (" + a.getFullYear() + "-" + a.getMonth() + "-" + a.getDate() + " " + (("0" + a.getHours()).slice(-2)) + ":" + (("0" + a.getMinutes()).slice(-2)) + ":" + (("0" + a.getSeconds()).slice(-2)) + "." + (("00" + a.getMilliseconds()).slice(-3)) + "): ";
				b.unshift(a);
				try {
					window.console && console.log && (console.log.apply ? console.log.apply(console, b) : console.log(b));
				}
				catch (d) {}
			}
		};

		// Track Ad Features - accepts interaction name and impression type
		var trackAdFeatures = function(_interaction, _noun) {
			// Establish var to track local mode
			var isServed;
			// Verify ad is not local
			try {
				isServed = EB._isServingMode();
			}
			catch (err) {}

			if (isServed && trackOnce) {
				try {
					// Update Boolean
					trackOnce = false;
					// Grab Version ID
					var adId = EB._adConfig.adId;
					// Establish reference for Version id
					var versionID;
					// Grab Version ID for mass versioning
					try {
						versionID = EB._adConfig.massVersioning.adVersions.split("_")[0];
					}
					catch (err) {
						versionID = "";
					}
					// Determine if tag is SAS
					var isSAS = (adId.toString().length >= 10);
					// Build Base Url for SAS and MDX
					var baseURL = (isSAS) ? "https://bs.serving-sys.com/Serving/adServer.bs?cn=display&c=19&pli=1073952795&adid=1073972634&ord=[timestamp]&rtu=-1&pcp=$$adID=" + adId + "|vID=" + versionID + "|interactionName=" : "https://bs.serving-sys.com/BurstingPipe/adServer.bs?cn=tf&c=19&mc=imp&pli=16478984&PluID=0&ord=%time%&rtu=-1&pcp=$$adID=" + adId + "|vId=" + versionID + "|interactionName=";
					// Build Tracking Pixel
					var trackingPixel = baseURL + _interaction + "|noun=" + _noun + "$$";
					// Fire Tracking Pixel by creating a new image.
					new Image().src = trackingPixel;

				}
				catch (err) {}
			}
		};

		// Set up Script
		var prepareFeature = function() {
			// Track Ad Feature
			trackAdFeatures("impression", "AF_" + scriptName + "_" + blockId);
			// init script
			init();
		};

		// set up script
		prepareFeature();

		// Return functions you want publically available
		return {
			getCurrentIndex: getCurrentIndex,
			getCurrentImage: getCurrentImage,
			showNavigation: showNavigation,
			hideNavigation: hideNavigation,
			showIndicator: showIndicator,
			hideIndicator: hideIndicator,
			showCaption: showCaption,
			hideCaption: hideCaption,
			goToNextImage: goToNextImage,
			goToPreviousImage: goToPreviousImage,
			goToImage: goToImage,
			clickThrough: clickThrough,
			resize: resize,
			refresh: refresh,
			addWidget: addWidget,
		};
	};
}());
